diff -ruN uppsrc/CodeEditor/Highlight.cpp uppsrc/CodeEditor/Highlight.cpp
--- uppsrc/CodeEditor/Highlight.cpp	2012-07-14 22:11:03 +0400
+++ uppsrc/CodeEditor/Highlight.cpp	2012-07-25 09:07:02 +0400
@@ -401,7 +401,7 @@
 			"CLASSNAME", "THISBACK", "THISBACK1", "THISBACK2", "THISBACK3", "THISBACK4",
 			"PTEBACK", "PTEBACK1", "PTEBACK2",  "PTEBACK3",  "PTEBACK4", 
 			"QUOTE", "XASSERT", "NEVER", "XNEVER", "CHECK", "XCHECK", "ASSERT",
-			"NAMESPACE_UPP", "END_UPP_NAMESPACE", "NEVER_", "SKYLARK",
+			"NAMESPACE_UPP", "END_UPP_NAMESPACE", "NEVER_", "SKYLARK", "RPC_METHOD", "RPC_GMETHOD",
 			NULL
 		};
 		static const char *upp_logs[] = {
diff -ruN uppsrc/Core/Rpc/Rpc.h uppsrc/Core/Rpc/Rpc.h
--- uppsrc/Core/Rpc/Rpc.h	2012-07-12 23:59:28 +0400
+++ uppsrc/Core/Rpc/Rpc.h	2012-07-25 13:25:02 +0400
@@ -235,15 +235,8 @@
 
 void   Register(const char *name, void (*method)(RpcData&), const char *group = NULL);
 
-#define RPC_METHOD(x) \
-void rpc_method_##x(RpcData& rpc); \
-INITBLOCK { Register(#x, rpc_method_##x); } \
-void rpc_method_##x(RpcData& rpc)
-
-#define RPC_GMETHOD(x, group) \
-void rpc_method_##x(RpcData& rpc); \
-INITBLOCK { Register(#x, rpc_method_##x, group); } \
-void rpc_method_##x(RpcData& rpc)
+#define RPC_METHOD(name) void name(RpcData& rpc); INITBLOCK { Register(#name, name); } void name(RpcData& rpc)
+#define RPC_GMETHOD(name, group) void name(RpcData& rpc); INITBLOCK { Register(#name, name, group); } void name(RpcData& rpc)
 
 struct RpcError {
 	int    code;
diff -ruN uppsrc/CppBase/keyword.i uppsrc/CppBase/keyword.i
--- uppsrc/CppBase/keyword.i	2012-07-14 22:11:03 +0400
+++ uppsrc/CppBase/keyword.i	2012-07-25 09:08:32 +0400
@@ -81,3 +81,6 @@
 CPPID(do)
 
 CPPID(SKYLARK)
+
+CPPID(RPC_METHOD)
+CPPID(RPC_GMETHOD)
diff -ruN uppsrc/CppBase/Parser.cpp uppsrc/CppBase/Parser.cpp
--- uppsrc/CppBase/Parser.cpp	2012-07-23 11:51:02 +0400
+++ uppsrc/CppBase/Parser.cpp	2012-07-25 14:24:47 +0400
@@ -668,22 +668,39 @@
 			break;
 	}
 	Qualifier();
-	if(l0 && lex == tk_SKYLARK && lex[1] == '(') {
-		++lex;
-		++lex;
-		Decl& a = r.Add();
-		a.name = lex.GetId();
-		a.function = true;
-		a.natural = String().Cat() << "void " << a.name << "(Http& http)";
-		Decl& p = a.param.Add();
-		p.name = "http";
-		p.type = "Http";
-		p.natural = "Http& http";
-		Key(',');
-		lex.GetText();
-		Key(')');
-		return r;
-	}
+	if(l0)
+		if(lex == tk_SKYLARK && lex[1] == '(') {
+			++lex;
+			++lex;
+			Decl& a = r.Add();
+			a.name = lex.GetId();
+			a.function = true;
+			a.natural = String().Cat() << "void " << a.name << "(Http& http)";
+			Decl& p = a.param.Add();
+			p.name = "http";
+			p.type = "Http";
+			p.natural = "Http& http";
+			Key(',');
+			lex.GetText();
+			Key(')');
+			return r;
+		} else
+		if((lex == tk_RPC_METHOD || lex == tk_RPC_GMETHOD) && lex[1] == '(') {
+			++lex;
+			++lex;
+			Decl& a = r.Add();
+			a.name = lex.GetId();
+			a.function = true;
+			a.natural = String().Cat() << "void " << a.name << "(RpcData& rpc)";
+			Decl& p = a.param.Add();
+			p.name = "rpc";
+			p.type = "RpcData";
+			p.natural = "RpcData& rpc";
+			if (Key(','))
+				lex.GetText();
+			Key(')');
+			return r;
+		}
 	bool isdestructor = Key('~');
 	if(l0 && context.typenames.Find(lex) >= 0 && lex[1] == '(' && lex.IsId()) {
 		Decl& a = r.Add();
